module("luci.controller.lucky",package.seeall)
function index()
if not nixio.fs.access("/etc/config/lucky")then
return
end
entry({"admin","services","lucky"},alias("admin","services","lucky","setting"),_("Lucky"),57).dependent=true
entry({"admin","services","lucky","setting"},cbi("lucky/lucky"),_("Base Setting"),20).leaf=true
entry({"admin","services","lucky_status"},call("act_status"))
entry({"admin","services","lucky_info"},call("lucky_info"))
entry({"admin","services","lucky_set_config"},call("lucky_set_config"))
entry({"admin","services","lucky_service"},call("lucky_service"))
end
function act_status()
local t=require"luci.sys"
local e={}
e.running=t.call("pgrep -f 'lucky -c' >/dev/null")==0
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function lucky_info()
local e={}
local t=luci.sys.exec("/usr/bin/lucky -info")
if(t~=nil)
then
e.luckyInfo=t
local t=GetLuckyConfigureObj()
if(t~=nil)
then
e.LuckyBaseConfigure=t["BaseConfigure"]
end
end
e.luckyArch=luci.sys.exec("/usr/bin/luckyarch")
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function lucky_set_config()
local t=luci.http.formvalue("key")
local a=luci.http.formvalue("value")
local e={}
e.ret=1
if(t=="admin_http_port")
then
e.ret=setLuckyConf("AdminWebListenPort",a)
end
if(t=="admin_safe_url")
then
e.ret=setLuckyConf("SetSafeURL",a)
end
if(t=="reset_auth_info")
then
setLuckyConf("AdminAccount","666")
setLuckyConf("AdminPassword","666")
luci.sys.exec("/etc/init.d/lucky restart")
e.ret=0
end
if(t=="switch_Internetaccess")
then
e.ret=setLuckyConf("AllowInternetaccess",a)
end
luci.http.prepare_content("application/json")
luci.http.write_json(e)
end
function lucky_service()
local e=luci.http.formvalue("action")
if(e=="restart")
then
luci.sys.exec("uci set  lucky.@lucky[0].enabled=1")
luci.sys.exec("uci commit")
luci.sys.exec("/etc/init.d/lucky restart")
end
if(e=="start")
then
luci.sys.exec("uci set  lucky.@lucky[0].enabled=1")
luci.sys.exec("uci commit")
luci.sys.exec("/etc/init.d/lucky start")
end
if(e=="stop")
then
luci.sys.exec("uci set  lucky.@lucky[0].enabled=0")
luci.sys.exec("uci commit")
luci.sys.exec("/etc/init.d/lucky stop")
end
end
function trim(e)
return(string.gsub(e,"^%s*(.-)%s*$","%1"))
end
function GetLuckyConfigureObj()
configPath=trim(luci.sys.exec("uci get lucky.@lucky[0].configdir"))
local e=luci.sys.exec("lucky -baseConfInfo -cd "..configPath)
configObj=luci.jsonc.parse(trim(e))
return configObj
end
function setLuckyConf(e,t)
configPath=trim(luci.sys.exec("uci get lucky.@lucky[0].configdir"))
cmd="/usr/bin/lucky ".." -setconf ".."-key "..e.." -value "..t.." -cd "..configPath
if(t=="")
then
cmd="/usr/bin/lucky ".." -setconf ".."-key "..e.." -cd "..configPath
end
luci.sys.exec(cmd)
return 0
end